/*
 * Copyright (C) 2001 Igor Sysoev.
 */

#include "httpd.h"

/* cache flags */

/*
   Content_Not_Modified
   CNT_NM_CHECKED and CNT_NM_DISABLED flags used in accel_check_ims().
   Now set by mod_randban only.
*/
#define CNT_NM_CHECKED          0x00000001
#define CNT_NM_DISABLED         0x00000002

/*
   Content_Range
   CNT_RANGE_CHECKED and CNT_RANGE_DISABLED flags used in accel_check_ranges().
   Now set by mod_randban and mod_quoted.
*/
#define CNT_RANGE_CHECKED       0x00000004
#define CNT_RANGE_DISABLED      0x00000008

/* content modules specific cache flags */
#define CNT_RANDBAN_CHECKED     0x00010000
#define CNT_RANDBAN_FOUND       0x00020000
#define CNT_QUOTED_CHECKED      0x00040000
#define CNT_QUOTED_FOUND        0x00080000
#define CNT_FREEZE_CHECKED      0x00100000
#define CNT_FREEZE_FOUND        0x00200000



/* content state flags */
#define CNT_FIRST               0x00000001    /* first block of content */
#define CNT_TAIL                0x00000002    /* block of content has tail */

typedef struct {
    char           *buf;
    int             len;
    int             in_flags;
    int             out_flags;
    int             state;
} accel_cnt;

typedef struct {
    int             state;
    struct in_addr  addr;
} backend_failed;

typedef struct {
    int             sock;
    char           *host;          /* backend hostname */
    struct in_addr  addr;          /* backend ip address */
    char           *port_str;      /* backend port, string value */
    int             port;          /* backend port */
    char           *path;          /* backend path */
} backend_rec;

typedef struct {
    request_rec    *r;
    backend_rec    *b;
    char           *url;
    struct in_addr  addr;
    int             timeout;
    int             so_rcvbuf;
    int            *backend;
    array_header   *backends;
    array_header   *failed;
    char           *path;
    char           *port_str;
} backend_connect;

typedef struct {
    int             status;
    char           *status_line;
    char           *line;
    table          *headers_out;
} header_rec;
