/*
 * Copyright (C) 2001 Igor Sysoev.
 */

#include "ap_ext_accel.h"

API_EXPORT_NONSTD(const char *) ap_set_integer_slot(cmd_parms *cmd,
                                                    char *struct_ptr, int arg)
{
    int offset = (int) (long) cmd->info;
    int size = atoi((char *)arg);

    if (size < 0)
        return ap_pstrcat(cmd->pool, cmd->cmd->name,
                          " must be integer greater or equal to zero", NULL);

    *(int *) (struct_ptr + offset) = size;
    return NULL;
}

API_EXPORT_NONSTD(const char *) ap_set_kilobytes_slot(cmd_parms *cmd,
                                                      char *struct_ptr, int arg)
{
    int offset = (int) (long) cmd->info;
    int size = atoi((char *)arg);

    if (size < 0)
        return ap_pstrcat(cmd->pool, cmd->cmd->name,
                          " must be integer greater or equal to zero", NULL);

    *(int *) (struct_ptr + offset) = size * 1024;
    return NULL;
}

API_EXPORT(int) ap_bblock(BUFF *fb, int direction)
{
    int fd;

    fd = (direction == B_RD) ? fb->fd_in : fb->fd;
#if defined(O_NONBLOCK)
    return fcntl(fd, F_SETFL, fcntl(fd, F_GETFL, 0) & ~O_NONBLOCK);
#elif defined(O_NDELAY)
    return fcntl(fd, F_SETFL, fcntl(fd, F_GETFL, 0) & ~O_NDELAY);
#elif defined(FNDELAY)
    return fcntl(fd, F_SETFL, fcntl(fd, F_GETFL, 0) & ~FNDELAY);
#else
    /* XXXX: this breaks things, but an alternative isn't obvious...*/
    return 0;
#endif
}
